protected/modules/admin/controllers/ProductController.php
<?php

class ProductController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $defaultAction = 'admin';
	public $layout='/layouts/column2';
    const IMAGE_FOLDER = '\\images\\products\\';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
			'postOnly + delete', // we only allow deletion via POST request
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow', // allow admin user to perform all actions
				'actions'=>array('admin','delete','create','update','getcats','index','view','feed'),
				'users'=>array('admin'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model=new Product;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Product']))
		{
                    $model->attributes=$_POST['Product'];
                    if($model->save()){
                        if ($model->image_file=CUploadedFile::getInstance($model,'image_file')) {
                            $fileName =  $model->id.'_'.$model->short.'.'.$model->image_file->extensionName;
                            $model->image_file->saveAs(Yii::getPathOfAlias('webroot') . self::IMAGE_FOLDER . $fileName);
                            $model->image = $fileName;
                            $model->save(FALSE);
                }
                $this->redirect('admin/product');
            }
		}
                $command = Yii::app()->db->createCommand("SELECT id, name FROM gs_mizzle_products");
                $mizzle_products = $command->queryAll();
		$this->render('create',array(
                        'mizzle_products'=>$mizzle_products,
			'model'=>$model,
		));
	}

    /**
     * Replaces spaces into " _ "
     */
    public static function renameImageFile($name){
        $symbols = array('?','/','!','"',"'",'+','*','(',')','&','^','%','$','#','@','`','~');
        $name = str_replace(' ','_',$name);
        $name = str_replace($symbols,'',$name);
        return $name;
    }

    /**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Product']))
		{
			$model->attributes=$_POST['Product'];
			if($model->save()){
				if ($model->image_file=CUploadedFile::getInstance($model,'image_file')) {
					$fileName =  $model->id.'_'.self::renameImageFile($model->short).'.'.$model->image_file->extensionName;
					$model->image_file->saveAs(Yii::getPathOfAlias('webroot') . self::IMAGE_FOLDER . $fileName);
					$model->image = $fileName;
					$model->save(FALSE);
				}
				$this->redirect(array('admin'));
			}

		}
                
                $command = Yii::app()->db->createCommand("SELECT id, name FROM gs_mizzle_products");
                $mizzle_products = $command->queryAll();
		$this->render('update',array(
			'model'=>$model,
                        'mizzle_products'=>$mizzle_products
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('Product');
		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Product('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Product']))
			$model->attributes=$_GET['Product'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Product the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model=Product::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Product $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='product-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}

    public function actionGetcats(){
        $data=Category::model()->findAll('game_id=:game_id',
            array(':game_id'=>(int) $_POST["Product"]['game_id']));
        $data=CHtml::listData($data,'id','name');
        foreach($data as $value=>$name)
        {
            echo CHtml::tag('option',
                array('value'=>$value),CHtml::encode($name),true);
        }
    }

	//
	public function actionFeed(){
		$games = Game::model()->findAll();
		$mizzle = new MizzleXML();
		$domain = Yii::app()->params['domain'];
		foreach($games as $game)
			foreach($game->products as $product){
				$mizzle->createPositionByUrl('http://mizzle.ru/product/'.$product->mizzle_product_id.'/'.$product->mizzle->hash, $product->price, $domain . "/game/" . $product->game->id);
			}
		$mizzle->prepare();
		$mizzle->save(Yii::getPathOfAlias('webroot'). "/" .Yii::app()->params["xmlFileName"]);
		$this->render('feed',array(
			'xmlFileName' => Yii::app()->params["xmlFileName"],
		));
	}
}

protected/modules/admin/views/product/_form.php
<?php
/* @var $this ProductController */
/* @var $model Product */
/* @var $form CActiveForm */
?>

<div class="form">

<?php 
//print_r($mizzle_products);exit;
$form=$this->beginWidget('CActiveForm', array(
	'id'=>'product-form',
    'htmlOptions'=>array('enctype'=>'multipart/form-data'),
	'enableAjaxValidation'=>false,
)); ?>

	<p class="note">Fields with <span class="required">*</span> are required.</p>

	<?php echo $form->errorSummary($model); ?>
    <table class="table table-striped">
        <tr>
            <td>
                <?php echo $form->labelEx($model,'game_id') ?>
            </td>
            <td>
                <?php echo $form->dropDownList($model,'game_id',Game::getAll(),array(
                    'ajax' => array(
                        'type'=>'POST', //request type
                        //'data'=>array('game_id'=>'js:this.val'),
                        'url'=>CController::createUrl('product/getcats'), //url to call.
                        //Style: CController::createUrl('currentController/methodToCall')
                        'update'=>'#Product_category_id', //selector to update
                        //'data'=>'#Game_id.val()'
                        //leave out the data key to pass all form values through
                    ))); ?>
                <?php echo $form->error($model,'game_id'); ?>
            </td>

        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'category_id'); ?>
            </td>
            <td>
                <?php if(!$model->isNewRecord){
					echo $form->dropDownList($model,'category_id', Category::getAll());
				}
				else
					echo $form->dropDownList($model,'category_id',array()); ?>

                <?php echo $form->error($model,'category_id'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'name'); ?>
            </td>
            <td>
                <?php echo $form->textField($model,'name',array('size'=>60,'maxlength'=>256)); ?>
                <?php echo $form->error($model,'name'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'mizzle_product_id'); ?>
            </td>
            <td>
		<?php
			$this->widget('ext.textList.textList', array(
				'model' => $model,
				'name' => 'mizzle_product_id',
				'value' => $model->mizzle_product_id,
				'item' => array(
						'id' => '$data["id"]',
						'value' => '$data["name"]',
					),
				'list' => $mizzle_products,
				'size' => 5,
				'htmlOptions' => array(
						'size'=>60,
						'maxlength'=>128,
					)
			));
		?>
                <?php echo $form->error($model,'mizzle_product_id'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'desc'); ?>
            </td>
            <td>
                <?php echo $form->textArea($model,'desc',array('rows'=>6, 'cols'=>50)); ?>
                <?php echo $form->error($model,'desc'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'image'); ?>
            </td>
            <td>
                <?php echo $form->textField($model,'image',array('size'=>64,'maxlength'=>64)); ?>
                <?php echo $form->fileField($model,'image_file'); ?>
                <?php echo $form->error($model,'image'); ?>
                <?php
                    if(!$model->isNewRecord) {
                        echo CHtml::image(Yii::app()->baseUrl.'/images/products/' . $model->image, $model->name, array('height'=>100));
                    }
                ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'short'); ?>
            </td>
            <td>
                <?php echo $form->textField($model,'short',array('size'=>32,'maxlength'=>32)); ?>
                <?php echo $form->error($model,'short'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'tags'); ?>
            </td>
            <td>
                <?php echo $form->textField($model,'tags',array('size'=>60,'maxlength'=>256)); ?>
                <?php echo $form->error($model,'tags'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'price'); ?>
            </td>
            <td>
                <?php echo $form->textField($model,'price'); ?>
                <?php echo $form->error($model,'price'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'count'); ?>
            </td>
            <td>
                <?php echo $form->textField($model,'count'); ?>
                <?php echo $form->error($model,'count'); ?>
            </td>
        </tr>
        <tr>
            <td>
                <?php echo $form->labelEx($model,'available'); ?>
            </td>
            <td>
                <?php echo $form->dropDownList($model,'available',array('1'=>'Доступно','0'=>'Недоступно')); ?>
                <?php echo $form->error($model,'available'); ?>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <div class="row buttons">
                    <?php echo CHtml::submitButton($model->isNewRecord ? 'Create' : 'Save',array('class'=>'btn btn-primary')); ?>
                </div>
            </td>
        </tr>
    </table>

<?php $this->endWidget(); ?>

</div><!-- form -->

<script>
    $("#Product_name").change(function(){
        $("#Product_short").val(toTranslit($('#Product_name').val()));
    });
</script>

protected/modules/admin/views/product/_search.php
<?php
/* @var $this ProductController */
/* @var $model Product */
/* @var $form CActiveForm */
?>

<div class="wide form">

<?php $form=$this->beginWidget('CActiveForm', array(
	'action'=>Yii::app()->createUrl($this->route),
	'method'=>'get',
)); ?>

	<div class="row">
		<?php echo $form->label($model,'id'); ?>
		<?php echo $form->textField($model,'id'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'category_id'); ?>
		<?php echo $form->textField($model,'category_id'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'game_id'); ?>
		<?php echo $form->textField($model,'game_id'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'isAggregator'); ?>
		<?php echo $form->textField($model,'isAggregator'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'name'); ?>
		<?php echo $form->textField($model,'name',array('size'=>60,'maxlength'=>256)); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'desc'); ?>
		<?php echo $form->textArea($model,'desc',array('rows'=>6, 'cols'=>50)); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'image'); ?>
		<?php echo $form->textField($model,'image',array('size'=>60,'maxlength'=>256)); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'short'); ?>
		<?php echo $form->textField($model,'short',array('size'=>32,'maxlength'=>32)); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'tags'); ?>
		<?php echo $form->textField($model,'tags',array('size'=>60,'maxlength'=>256)); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'price'); ?>
		<?php echo $form->textField($model,'price'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'count'); ?>
		<?php echo $form->textField($model,'count'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'available'); ?>
		<?php echo $form->textField($model,'available'); ?>
	</div>

	<div class="row">
		<?php echo $form->label($model,'watched'); ?>
		<?php echo $form->textField($model,'watched'); ?>
	</div>

	<div class="row buttons">
		<?php echo CHtml::submitButton('Search'); ?>
	</div>

<?php $this->endWidget(); ?>

</div><!-- search-form -->

protected/modules/admin/views/product/_view.php
<?php
/* @var $this ProductController */
/* @var $data Product */
?>

<div class="view">

	<b><?php echo CHtml::encode($data->getAttributeLabel('id')); ?>:</b>
	<?php echo CHtml::link(CHtml::encode($data->id), array('view', 'id'=>$data->id)); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('category_id')); ?>:</b>
	<?php echo CHtml::encode($data->category_id); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('game_id')); ?>:</b>
	<?php echo CHtml::encode($data->game_id); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('isAggregator')); ?>:</b>
	<?php echo CHtml::encode($data->isAggregator); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('name')); ?>:</b>
	<?php echo CHtml::encode($data->name); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('desc')); ?>:</b>
	<?php echo CHtml::encode($data->desc); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('image')); ?>:</b>
	<?php echo CHtml::encode($data->image); ?>
	<br />

	<?php /*
	<b><?php echo CHtml::encode($data->getAttributeLabel('short')); ?>:</b>
	<?php echo CHtml::encode($data->short); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('tags')); ?>:</b>
	<?php echo CHtml::encode($data->tags); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('price')); ?>:</b>
	<?php echo CHtml::encode($data->price); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('count')); ?>:</b>
	<?php echo CHtml::encode($data->count); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('available')); ?>:</b>
	<?php echo CHtml::encode($data->available); ?>
	<br />

	<b><?php echo CHtml::encode($data->getAttributeLabel('watched')); ?>:</b>
	<?php echo CHtml::encode($data->watched); ?>
	<br />

	*/ ?>

</div>

protected/modules/admin/views/product/admin.php
<?php
/* @var $this ProductController */
/* @var $model Product */

$this->breadcrumbs=array(
	'Products'=>array('index'),
	'Manage',
);

$this->menu=array(
	array('label'=>'Создать новый товар', 'url'=>array('create')),
	array('label'=>'Создать файл XML', 'url'=>array('feed')),
);

Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$('#product-grid').yiiGridView('update', {
		data: $(this).serialize()
	});
	return false;
});
");
?>

<h1>Управление товарами</h1>


<?php echo CHtml::link('Advanced Search','#',array('class'=>'search-button')); ?>
<div class="search-form" style="display:none">
<?php $this->renderPartial('_search',array(
	'model'=>$model,
)); ?>
</div><!-- search-form -->

<?php $this->widget('zii.widgets.grid.CGridView', array(
	'id'=>'product-grid',
	'dataProvider'=>$model->search(),
	'filter'=>$model,
	'ajaxUpdate'=>false,
	'columns'=>array(
		'id',
		array(
			'name'=>'category.name',
		),
		'category_id',
		'mizzle_product_id',
		'game_id',
		//'isAggregator',
		'name',
		'desc',
		'price',
		/*
		'image',
		'short',
		'tags',
		'count',
		'available',
		'watched',
		*/
		array(
			'class'=>'CButtonColumn',
		),
	),
)); ?>

protected/modules/admin/views/product/create.php
<?php
/* @var $this ProductController */
/* @var $model Product */

$this->breadcrumbs=array(
	'Products'=>array('index'),
	'Create',
);

$this->menu=array(
	array('label'=>'List Product', 'url'=>array('index')),
	array('label'=>'Manage Product', 'url'=>array('admin')),
);
?>

<h1>Create Product</h1>

<?php echo $this->renderPartial('_form', array('model'=>$model,'mizzle_products'=> $mizzle_products)); ?>

protected/modules/admin/views/product/feed.php
<?php
/**
 * Created by PhpStorm.
 * User: _muzart
 * Date: 23.12.13
 * Time: 2:31
 */
$this->menu=array(
	array('label'=>'Создать новый товар', 'url'=>array('create')),
	array('label'=>'Управление товарами', 'url'=>array('admin')),
);

?>
<p>Ваш прайслист был успешно создан!</p>
<p><a href="<?php echo Yii::app()->baseUrl ."/". $xmlFileName?>"><?php echo $xmlFileName;?></a></p>

protected/modules/admin/views/product/index.php
<?php
/* @var $this ProductController */
/* @var $dataProvider CActiveDataProvider */

$this->breadcrumbs=array(
	'Products',
);

$this->menu=array(
	array('label'=>'Create Product', 'url'=>array('create')),
	array('label'=>'Manage Product', 'url'=>array('admin')),
);
?>

<h1>Products</h1>

<?php $this->widget('zii.widgets.CListView', array(
	'dataProvider'=>$dataProvider,
	'itemView'=>'_view',
)); ?>

protected/modules/admin/views/product/update.php
<?php
/* @var $this ProductController */
/* @var $model Product */

$this->breadcrumbs=array(
	'Products'=>array('index'),
	$model->name=>array('view','id'=>$model->id),
	'Update',
);

$this->menu=array(
	array('label'=>'List Product', 'url'=>array('index')),
	array('label'=>'Create Product', 'url'=>array('create')),
	array('label'=>'View Product', 'url'=>array('view', 'id'=>$model->id)),
	array('label'=>'Manage Product', 'url'=>array('admin')),
);
?>

<h1>Update Product <?php echo $model->id; ?></h1>

<?php echo $this->renderPartial('_form', array('model'=>$model,'mizzle_products'=>$mizzle_products)); ?>

protected/modules/admin/views/product/view.php
<?php
/* @var $this ProductController */
/* @var $model Product */

$this->breadcrumbs=array(
	'Products'=>array('index'),
	$model->name,
);

$this->menu=array(
	array('label'=>'List Product', 'url'=>array('index')),
	array('label'=>'Create Product', 'url'=>array('create')),
	array('label'=>'Update Product', 'url'=>array('update', 'id'=>$model->id)),
	array('label'=>'Delete Product', 'url'=>'#', 'linkOptions'=>array('submit'=>array('delete','id'=>$model->id),'confirm'=>'Are you sure you want to delete this item?')),
	array('label'=>'Manage Product', 'url'=>array('admin')),
);
?>

<h1>View Product #<?php echo $model->id; ?></h1>

<?php $this->widget('zii.widgets.CDetailView', array(
	'data'=>$model,
	'attributes'=>array(
		'id',
		'category_id',
		'game_id',
		'isAggregator',
		'name',
		'desc',
		'image',
		'short',
		'tags',
		'price',
		'count',
		'available',
		'watched',
	),
)); ?>